//
//      HelloWorld.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.
//

#include "HelloWorld.hpp"

//
// The Boot loader function.
// It is called when the application starts.
//
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://";

    return (id == AEECLSID_HELLOWORLD) ? (&HelloWorld::Factory) : (null);
}

//
// The factory function.
// An instance of the application class is generated and returned.
//
SFCInvokerPtr HelloWorld::Factory(Void)
{
    return ::new HelloWorld;
}

//
// Constructor definition.
// Nothing special is done here.
//
HelloWorld::HelloWorld(Void) static_throws
{
    return;
}

//
// Destructor definition.
// Nothing special is done here.
//
HelloWorld::~HelloWorld(Void)
{
    return;
}

//
// Event handler.
//
Bool HelloWorld::Invoke(SFXEventConstRef event)
{
    Bool result(false);

    switch (event.GetType()) {
        case SFEVT_KEY:
            result = OnKey(event.GetP16());
            break;
    }
    if (!result) {
        result = SFCApplication::Invoke(event);
    }
    return result;
}

Void Draw(Void)
{
    // Get an instance of the SFXGraphics class
    SFXGraphicsPtr graphics = SFXGraphics::GetInstance();

    if (graphics != null) {
        // The screen is cleared by painting it white
        // The entire screen rectangle is obtained by SFXGraphics::GetDeviceRectangle()
        // SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00) defines a color
        graphics->FillRectangle(SFXGraphics::GetDeviceRectangle(),
                    SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00));
    
        // The string "Hello World" is drawn on screen
        graphics->DrawText("Hello World", SFXGraphics::GetDeviceRectangle(),
                    SFXRGBColor(0x00, 0x00, 0x00, 0x00));
    
        // The screen is updated (this operation must be done)
        graphics->Update();
    }
    return;
}

//
// Key handler.
//
Bool HelloWorld::OnKey(UInt16 key)
{
    // Key push processing is described here
    // If the select key is pushed, the application program is closed

    switch (key) {
        case AVK_SELECT:
            Terminate();
            return true;

    // When the "1" key is pressed the Draw() function is called
        case AVK_1:
            Draw();
            return true;

    }
    return false;
}
